( floating point maths routines )
CLS CR CR 3 1 CSIZE
.(   LOADING FLOATING POINT) CR
.(      MATHS PACKAGE) CR  0 0 CSIZE
HEX
CREATE C_FP     ( ad n1 --- n2 )
       HERE DUP 2- !
       3002 , 4287 , 2F09 , 2F0C , 385B ,
       D9CA , 224B , 9DCE , 3A78 , 011C ,
       4E95 , 3400 , 2649 , 285F , 225F ,
       3219 , 3A72 , 1000 , 4EF2 , D000 ,
CREATE FP$    ( fp ad vec --- ad D0    )
              (    ad vec --- fp ad D0 )
       HERE DUP 2- !
       48E4 , 00E0 , 4287 , 3A42 , 3A55 ,
       305B , D1CA , 224B , 9DCE , 4E95 ,
       2649 , 2408 , 4CDC , 0700 , 948A ,
       3702 , 3400 , 3219 , 3A72 , 1000 ,
       4EF2 , D000 ,
CREATE FDUP  HERE DUP 2- !     3702 , 272B , 0002 ,
                 3219 , 3A72 , 1000 , 4EF2 , D000 ,
CREATE FDROP     HERE DUP 2- !
                 588B , 341B , 60E6 ,
CREATE FSWAP     HERE DUP 2- !
                 221B , 361B , 2A5B , 2701 , 3702 ,
                 270D , 3403 , 60CC ,
CREATE FOVER     HERE DUP 2- !
                 3702 , 272B , 0008 , 342B , 000A ,
                 60B6 ,
CREATE F@     HERE DUP 2- !
              2732 , 2002 , 3432 , 2000 , 60A4 ,
CREATE F!     HERE DUP 2- !
              259B , 2000 , 359B , 2004 , 341B , 6090 ,
CREATE F>R    HERE DUP 2- !
              291B , 3902 , 341B , 6000 , FF80 ,
CREATE FR>    HERE DUP 2- !
              3702 , 341C , 271C , 6000 , FF6E ,
DECIMAL
: FROT  F>R FSWAP FR> FSWAP ;
: FCONSTANT 2CONSTANT , DOES> F@ ;
: FVARIABLE 2VARIABLE 0 , ;
: F0= OR OR 0= ;
: F0< DROP SWAP DROP 0< ;
: F0> DROP SWAP DROP 0> ;
: FPR 3 * 2 + 3 0 ;
: FPICK FPR DO >R R@ PICK R> LOOP DROP ;
: FROLL FPR DO >R R@ ROLL R> LOOP DROP ;
: FLOP CONSTANT DOES> @ 0 SWAP C_FP DUP ?ERROR ;
 2 FLOP F->S   4 FLOP INT     6 FLOP F->D    8 FLOP S->F
10 FLOP F+    12 FLOP F-     14 FLOP F*     16 FLOP F/
18 FLOP FABS  20 FLOP FNEGATE         24 FLOP COS
26 FLOP SIN        28 FLOP TAN        30 FLOP COT
32 FLOP ARCSIN     34 FLOP ARCCOS     36 FLOP ARCTAN
38 FLOP ARCCOT     40 FLOP SQRT       42 FLOP LN
44 FLOP LOG10      46 FLOP EXP        48 FLOP ^
: F< F- F0< ;   : F> F- F0> ;   : F= F- F0= ;
: F. PAD 240 FP$ DROP PAD SWAP PAD - TYPE SPACE  ;
: F$ BL WORD 1+ 256 FP$ DUP ?ERROR DROP ;
F$ 65536 FCONSTANT MI
: D->F >R S->F FDUP F0< IF MI F+ THEN
       R> S->F MI F* F+ ;
CLS .( Floating point maths package loaded )
END_FILE 
